/*
 * Copyright 2016 Ecole des Mines de Saint-Etienne.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.etsi.saref.server.resources;

import com.github.mustachejava.DefaultMustacheFactory;
import com.github.mustachejava.Mustache;
import com.github.mustachejava.MustacheFactory;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import org.glassfish.jersey.server.mvc.Template;


@Path("/view")
public class ListExercises {

    @GET
    @Produces(MediaType.TEXT_HTML)
    @Template(name = "/view")
    public Map<String, Object> getView() throws IOException {
        Map<String, Object> model = new HashMap<String, Object>();
        model.put("title", "OS");
        Set<OsInfo> oses = new HashSet<OsInfo>();
        OsInfo i = new OsInfo();
        i.name = "iOS";
        i.vendor = "Apple";
        i.version = 8;
        oses.add(i);
        i = new OsInfo();
        i.name = "Android";
        i.vendor = "Google";
        i.version = 5;
        oses.add(i);
        i = new OsInfo();
        i.name = "WindowsPhone";

        StringWriter sw = new StringWriter();
        MustacheFactory mf = new DefaultMustacheFactory();
        Mustache mustache = mf.compile("templates/beans.mustache");
        mustache.execute(sw, new Bean()).flush();
        i.vendor = sw.toString();

        i.version = 9;
        oses.add(i);
        model.put("os", oses);
        
        return model;

    }
}
